#version 430 core

layout (points) in; // points in
layout (triangle_strip, max_vertices = 4) out; // quads out

uniform mat4 ProjectionMatrix;

in vData { float TTL1;
vec3 position_world; } vertex[]; // from vertex shader
out vec2 TexCoord0;
flat out float TTL0; // flat: no interpolation between vertices

void main (void) {
	const vec2 size = vec2(1, 1);
	vec4 P = gl_in[0].gl_Position; // view-space position

	// a: left-bottom 
	vec2 va = P.xy + vec2(-0.5, -0.5) * size;
	gl_Position = ProjectionMatrix * vec4(va, P.zw);
	TexCoord0 = vec2(0.0, 0.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex();
  
	// b: right-bottom
	vec2 vd = P.xy + vec2(0.5, -0.5) * size;
	gl_Position = ProjectionMatrix * vec4(vd, P.zw);
	TexCoord0 = vec2(1.0, 0.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex();

	// c: left-top
	vec2 vb = P.xy + vec2(-0.5, 0.5) * size;
	gl_Position = ProjectionMatrix * vec4(vb, P.zw);
	TexCoord0 = vec2(0.0, 1.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex();
  
	// d: right-top
	vec2 vc = P.xy + vec2(0.5, 0.5) * size;
	gl_Position = ProjectionMatrix * vec4(vc, P.zw);
	TexCoord0 = vec2(1.0, 1.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex();

	EndPrimitive();
}
