#version 430 core
/*
* Copyright 2010 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec3 n;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform float offset;

void main() {
	vert.normal_world = normalMatrix * normal;
	// amplitude * sinus(postion*frequenz + 2pi * offset[0,1]) * vec3(0,1,0)
        vec3 height = (0.25* (1+sin(position.x*15 + 3.14159265 * 2 * offset))/2 ) * normal;
	vec4 position_world_ = modelMatrix * vec4(height+position, 1);
	vert.position_world = position_world_.xyz;
	float gradientx = (0.785398*cos(15*position.x + 3.14159265 * 2 * offset));
	vert.n = normalize(vec3(gradientx, 0, sqrt(1-gradientx*gradientx)));
	gl_Position = viewProjMatrix * position_world_;
}